import contextlib
import unittest
import io
import unittest.mock
from unittest import TextTestRunner

class MainTest(unittest.TestCase):

    def test_answer(self):

        def nearest_test(x_train, x_test):
            nearest = None; min_distance = None
            for i in range(len(x_train)):
                d = dist(x_train[i], x_test)
                if nearest == None or d < min_distance:
                    nearest = i
                    min_distance = d
            return nearest

        for x in range(10):
            x_train = np.random.rand(10, 3)
            x_test = np.random.rand(3) 

            capturedOutput = io.StringIO()                 
            sys.stdout = capturedOutput                     
            nearest(x_train, x_test)
            sys.stdout = sys.__stdout__ 
            output = capturedOutput.getvalue().strip()
            
            self.assertEqual(output, str(nearest_test(x_train, x_test)))

test_suite = unittest.TestLoader().loadTestsFromTestCase(MainTest)
with io.StringIO() as buf:
    # run the tests
    with contextlib.redirect_stdout(buf):
        TextTestRunner(stream=buf).run(test_suite)
    # process (in this case: print) the results
    printTest(buf.getvalue())