import unittest, sys
import io
import unittest.mock
import math
import numpy as np

from tmc import points

from tmc.utils import load, get_out

main = load('src.main', 'nearest')

def dist(a, b):
    sum = 0
    for ai, bi in zip(a, b):
        sum = sum + (ai - bi)**2
    return np.sqrt(sum)
        
def nearest_test(x_train, x_test):
    nearest = None; min_distance = None
    for i in range(len(x_train)):
        d = dist(x_train[i], x_test)
        if nearest == None or d < min_distance:
            nearest = i
            min_distance = d
    return nearest

@points('3-5')
class MainTest(unittest.TestCase):

    def test_answer_one(self):
            x_train = np.random.rand(10, 3)
            x_test = np.random.rand(3)
            main(x_train, x_test)
            output = get_out()
            self.assertEqual(output, str(nearest_test(x_train, x_test)))

    def test_answer_two(self):
            x_train = np.random.rand(10, 3)
            x_test = np.random.rand(3)
            main(x_train, x_test)
            output = get_out()
            self.assertEqual(output, str(nearest_test(x_train, x_test)))

    def test_answer_three(self):
            x_train = np.random.rand(10, 3)
            x_test = np.random.rand(3)
            main(x_train, x_test)
            output = get_out()
            self.assertEqual(output, str(nearest_test(x_train, x_test)))

    def test_answer_four(self):
            x_train = np.random.rand(10, 3)
            x_test = np.random.rand(3)
            main(x_train, x_test)
            output = get_out()
            self.assertEqual(output, str(nearest_test(x_train, x_test)))

    def test_answer_five(self):
            x_train = np.random.rand(10, 3)
            x_test = np.random.rand(3)
            main(x_train, x_test)
            output = get_out()
            self.assertEqual(output, str(nearest_test(x_train, x_test)))

    def test_answer_six(self):
            x_train = np.random.rand(10, 3)
            x_test = np.random.rand(3)
            main(x_train, x_test)
            output = get_out()
            self.assertEqual(output, str(nearest_test(x_train, x_test)))

    def test_answer_seven(self):
            x_train = np.random.rand(10, 3)
            x_test = np.random.rand(3)
            main(x_train, x_test)
            output = get_out()
            self.assertEqual(output, str(nearest_test(x_train, x_test)))

    def test_answer_eight(self):
            x_train = np.random.rand(10, 3)
            x_test = np.random.rand(3)
            main(x_train, x_test)
            output = get_out()
            self.assertEqual(output, str(nearest_test(x_train, x_test)))

    def test_answer_nine(self):
            x_train = np.random.rand(10, 3)
            x_test = np.random.rand(3)
            main(x_train, x_test)
            output = get_out()
            self.assertEqual(output, str(nearest_test(x_train, x_test)))

    def test_answer_ten(self):
            x_train = np.random.rand(10, 3)
            x_test = np.random.rand(3)
            main(x_train, x_test)
            output = get_out()
            self.assertEqual(output, str(nearest_test(x_train, x_test)))
          
if __name__ == '__main__':
    unittest.main()
